export interface MediaType<Name extends string = string> {
	name: Name;
	serialize: <T>(object: T) => string;
	deserialize: <T>(s: string) => T;
}

export const FALLBACK_MEDIA_TYPE = {
	serialize: (obj: unknown) => JSON.stringify(obj),
	deserialize: (str: string) => JSON.parse(str),
	name: 'application/json' as const,
} satisfies MediaType;

export const PATCH_CONTENT_TYPES = [
	'application/merge-patch+json',
	'application/json-patch+json',
] as const;

export type PatchContentType = typeof PATCH_CONTENT_TYPES[number];
